package com.siemag.staless.beans;

import java.io.Serializable;

import javax.annotation.Resource;
import javax.ejb.Stateless;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.ObjectMessage;
import javax.jms.Session;
import javax.jms.Topic;
import javax.jms.TopicConnection;
import javax.jms.TopicConnectionFactory;
import javax.jms.TopicPublisher;
import javax.jms.TopicSession;

import org.jboss.logging.Logger;

import com.siemag.staless.service.Tel100ControllerRemote;

/**
 * Session Bean implementation class Tel100Controller
 */
@Stateless(mappedName = "Hellao")
public class Tel100Controller implements Tel100ControllerRemote {
  Logger                    lLog = Logger.getLogger(Tel100Controller.class);
  //  @Resource(mappedName = "java:/JmsXA")
  @Resource(mappedName = "/ConnectionFactory")
  private ConnectionFactory connectionFactory;

  @Resource(mappedName = "topic/MES")
  private Topic             lTopic;

  /**
   * Default constructor.
   */
  public Tel100Controller() {

  }

  @Override
  public <T extends Serializable> T send(T serializable){
    TopicConnection con = null;
    TopicSession ses = null;
    TopicPublisher publisher = null;
    try
    {
      TopicConnectionFactory tcf = (TopicConnectionFactory)connectionFactory;
      con = tcf.createTopicConnection();
      ses = con.createTopicSession(false, Session.AUTO_ACKNOWLEDGE);
      publisher = ses.createPublisher(lTopic);
      con.start();
      ObjectMessage msg = ses.createObjectMessage(serializable);
      publisher.publish(msg);
      lLog.info("Sen d " + serializable.toString());
      return serializable;

    } catch (JMSException e)
    {
      throw new RuntimeException(e);
    } finally
    {
      try {
        publisher.close();
        con.close();
      } catch (JMSException e) {
        throw new RuntimeException(e);
      }
    }
  }
}
